package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.data.DataEnum;
import de.uni_marburg.powersort.sort.SortEnum;

import java.util.List;

public class Filter {
    /* Utility Class */
    private Filter() {
    }

    public static boolean isFiltered(DataEnum d, SortEnum s) {

        if (s == SortEnum.QUICK_SORT) {
            return List.of(
                    DataEnum.RANDOM_INTEGERS_300M,
                    DataEnum.ASCENDING_INTEGERS_300M,
                    DataEnum.DESCENDING_INTEGERS_250M,
                    DataEnum.ASCENDING_RUNS_1M
            ).contains(d);
        }

        if (s == SortEnum.MERGE_SORT) {
            return List.of(
                    DataEnum.RANDOM_INTEGERS_300M,
                    DataEnum.ASCENDING_INTEGERS_300M,
                    DataEnum.DESCENDING_INTEGERS_250M
            ).contains(d);
        }

        if (s == SortEnum.BUBBLE_SORT) {
            return List.of(
                    DataEnum.DESCENDING_INTEGERS_250M,
                    DataEnum.ASCENDING_RUNS_1M,
                    DataEnum.ASCENDING_RUNS_WITH_OVERLAP_1M
            ).contains(d);
        }

        // TODO: Remove this once performance of FinnSort improved
        if (s == SortEnum.FINN_SORT) {
            return List.of(
                    DataEnum.DESCENDING_INTEGERS_250M
            ).contains(d);
        }

        return false;
    }
}
