package de.uni_marburg.powersort.benchmark;

public class IntegerArray {
    private IntegerArray() {
    }

    public static Integer[] random(final int length, final long seed) {
        final Integer[] list = new Integer[length];
        for (int i = 0; i < length; i++) {
            list[i] = RandomInt.integer(seed);
        }
        return list;
    }

    /**
     * @return [high, high-1, ..., low+1, low]
     */
    public static Integer[] descending(final int high, final int low) {
        assert high >= low;

        Integer[] list = new Integer[high - low + 1];
        for (int i = 0; i < list.length; i++) {
            int value = high - i;
            list[i] = value;
        }

        assert list[0] == high;
        assert list[list.length - 1] == low;
        return list;
    }
    /**
     * @return [low, low-1, ..., high+1, high]
     */
    public static Integer[] ascending(final int low, final int high) {
        assert low <= high;

        Integer[] list = new Integer[high - low + 1];
        for (int i = 0; i < list.length; i++) {
            int value = low + i;
            list[i] = value;
        }

        assert list[0] == low;
        assert list[list.length - 1] == high;
        return list;
    }
}
