package de.uni_marburg.powersort.data;

import java.util.Arrays;

public abstract class  ObjectSupplier {
    public static final ObjectSupplier EMPTY_ARRAY = new ObjectSupplier(new Object[0]) {};

    /* package-protected */ final Object[] readOnly;

    ObjectSupplier(Object[] readOnly) {
        this.readOnly = readOnly;
    }

    /**
     * @return A fresh copy of the array of objects represented by this object.
     */
    public Object[] getCopy(){
        return Arrays.copyOf(readOnly, readOnly.length);
    }
}
