package de.uni_marburg.powersort;

import org.junit.jupiter.params.converter.SimpleArgumentConverter;

import java.util.Arrays;

public class JUnitUtil {
    /**
     * https://stackoverflow.com/a/46850299/6334421
     */
    public static class IntArrayConverter extends SimpleArgumentConverter {
        @Override
        protected int[] convert(Object source, Class<?> targetType) {
            if (source instanceof String s && int[].class.isAssignableFrom(targetType)) {
                if (s.isEmpty()) {
                    return new int[0];
                }
                String[] strings = s.split("\\s*\\|\\s*");
                return Arrays.stream(strings).mapToInt(Integer::valueOf).toArray();
            } else {
                throw new IllegalArgumentException("Conversion from " + source.getClass()
                        + " to " + targetType + " not supported.");
            }
        }
    }
    public static class IntegerArrayConverter extends SimpleArgumentConverter {
        @Override
        protected Integer[] convert(Object source, Class<?> targetType) {
            if (source instanceof String s && Integer[].class.isAssignableFrom(targetType)) {
                if (s.isEmpty()) {
                    return new Integer[0];
                }
                String[] strings = s.split("\\s*\\|\\s*");
                return Arrays.stream(strings).map(Integer::valueOf).toArray(Integer[]::new);
            } else {
                throw new IllegalArgumentException("Conversion from " + source.getClass()
                        + " to " + targetType + " not supported.");
            }
        }
    }
}
