package de.uni_marburg.powersort.benchmark;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

class RandomIntTest {
    protected RandomIntTest() {
        // This constructor is intentionally empty. Nothing special is needed here.
    }

    @Test
    void testRandomInt() {
        final double accuracy = 0.99;
        final int min = (int) Math.round(Integer.MIN_VALUE * accuracy);
        final int max = (int) Math.round(Integer.MAX_VALUE * accuracy);

        boolean minPassed = false;
        boolean maxPassed = false;
        for (int i = 0; i < 1000; i++) {
            final int random = RandomInt.integer();
            System.out.println(random); //NOPMD - suppressed SystemPrintln - Testing

            if (random <= min) {
                minPassed = true;
            }
            if (random >= max) {
                maxPassed = true;
            }
            if (minPassed && maxPassed) {
                return;
            }
        }

        Assertions.fail("min or max not reached - not a random int generator");
    }

    @Test
    void testReproducibility() {
        long seed = 1337;

        int expected = 2147483647;
        long actual = RandomInt.integer(seed);

        assertEquals(expected, actual);
    }
}
